    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ----------------------------
    028 * IntervalCategoryDataset.java
    029 * ----------------------------
    030 * (C) Copyright 2002-2008, by Eduard Martinescu and Contributors.
    031 *
    032 * Original Author:  Eduard Martinescu;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * Changes
    036 * -------
    037 * 19-Mar-2002 : Version 1 contributed by Eduard Martinescu.  The interface
    038 *               name and method names have been renamed to be consistent with
    039 *               existing interfaces (DG);
    040 * 06-Jun-2002 : Updated Javadoc comments (DG);
    041 * 24-Oct-2002 : Categories and series are now indexed by int or Comparable,
    042 *               following changes made to the CategoryDataset interface (DG);
    043 * 12-May-2008 : Updated API docs (DG);
    044 *
    045 */
    046
    047package org.jfree.data.category;
    048
    049/**
    050 * A category dataset that defines a value range for each series/category
    051 * combination.
    052 */
    053public interface IntervalCategoryDataset extends CategoryDataset {
    054
    055    /**
    056     * Returns the start value for the interval for a given series and category.
    057     *
    058     * @param series  the series (zero-based index).
    059     * @param category  the category (zero-based index).
    060     *
    061     * @return The start value (possibly <code>null</code>).
    062     *
    063     * @see #getEndValue(int, int)
    064     */
    065    public Number getStartValue(int series, int category);
    066
    067    /**
    068     * Returns the start value for the interval for a given series and category.
    069     *
    070     * @param series  the series key.
    071     * @param category  the category key.
    072     *
    073     * @return The start value (possibly <code>null</code>).
    074     *
    075     * @see #getEndValue(Comparable, Comparable)
    076     */
    077    public Number getStartValue(Comparable series, Comparable category);
    078
    079    /**
    080     * Returns the end value for the interval for a given series and category.
    081     *
    082     * @param series  the series (zero-based index).
    083     * @param category  the category (zero-based index).
    084     *
    085     * @return The end value (possibly <code>null</code>).
    086     *
    087     * @see #getStartValue(int, int)
    088     */
    089    public Number getEndValue(int series, int category);
    090
    091    /**
    092     * Returns the end value for the interval for a given series and category.
    093     *
    094     * @param series  the series key.
    095     * @param category  the category key.
    096     *
    097     * @return The end value (possibly <code>null</code>).
    098     *
    099     * @see #getStartValue(Comparable, Comparable)
    100     */
    101    public Number getEndValue(Comparable series, Comparable category);
    102
    103}